/[gentoo-x86]/eclass/linux-info.eclass
Gentoo

Diff of /eclass/linux-info.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.56 Revision 1.62
1# Copyright 1999-2006 Gentoo Foundation 1# Copyright 1999-2006 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-info.eclass,v 1.56 2008/10/31 22:01:32 dsd Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-info.eclass,v 1.62 2009/09/06 22:54:58 robbat2 Exp $
4# 4#
5# Original author: John Mylchreest <johnm@gentoo.org> 5# Original author: John Mylchreest <johnm@gentoo.org>
6# Maintainer: kernel-misc@gentoo.org 6# Maintainer: kernel-misc@gentoo.org
7# 7#
8# Please direct your bugs to the current eclass maintainer :) 8# Please direct your bugs to the current eclass maintainer :)
11# @MAINTAINER: 11# @MAINTAINER:
12# kernel-misc@gentoo.org 12# kernel-misc@gentoo.org
13# @BLURB: eclass used for accessing kernel related information 13# @BLURB: eclass used for accessing kernel related information
14# @DESCRIPTION: 14# @DESCRIPTION:
15# This eclass is used as a central eclass for accessing kernel 15# This eclass is used as a central eclass for accessing kernel
16# related information for sources already installed. 16# related information for source or binary already installed.
17# It is vital for linux-mod.eclass to function correctly, and is split 17# It is vital for linux-mod.eclass to function correctly, and is split
18# out so that any ebuild behaviour "templates" are abstracted out 18# out so that any ebuild behaviour "templates" are abstracted out
19# using additional eclasses. 19# using additional eclasses.
20#
21# "kernel config" in this file means:
22# The .config of the currently installed sources is used as the first
23# preference, with a fall-back to bundled config (/proc/config.gz) if available.
20 24
21# A Couple of env vars are available to effect usage of this eclass 25# A Couple of env vars are available to effect usage of this eclass
22# These are as follows: 26# These are as follows:
23 27
24# @ECLASS-VARIABLE: KERNEL_DIR 28# @ECLASS-VARIABLE: KERNEL_DIR
36# You can also check that an option doesn't exist by 40# You can also check that an option doesn't exist by
37# prepending it with an exclamation mark (!). 41# prepending it with an exclamation mark (!).
38# 42#
39# e.g.: CONFIG_CHECK="!MTRR" 43# e.g.: CONFIG_CHECK="!MTRR"
40# 44#
41# To simply warn about a missing option, prepend a '~'. 45# To simply warn about a missing option, prepend a '~'.
46# It may be combined with '!'.
47#
48# In general, most checks should be non-fatal. The only time fatal checks should
49# be used is for building kernel modules or cases that a compile will fail
50# without the option.
51#
52# This is to allow usage of binary kernels, and minimal systems without kernel
53# sources.
42 54
43# @ECLASS-VARIABLE: ERROR_<CFG> 55# @ECLASS-VARIABLE: ERROR_<CFG>
44# @DESCRIPTION: 56# @DESCRIPTION:
45# A string containing the error message to display when the check against CONFIG_CHECK 57# A string containing the error message to display when the check against CONFIG_CHECK
46# fails. <CFG> should reference the appropriate option used in CONFIG_CHECK. 58# fails. <CFG> should reference the appropriate option used in CONFIG_CHECK.
86 98
87# @ECLASS-VARIABLE: KV_OUT_DIR 99# @ECLASS-VARIABLE: KV_OUT_DIR
88# @DESCRIPTION: 100# @DESCRIPTION:
89# A read-only variable. It's a string containing the kernel object directory, will be KV_DIR unless 101# A read-only variable. It's a string containing the kernel object directory, will be KV_DIR unless
90# KBUILD_OUTPUT is used. This should be used for referencing .config. 102# KBUILD_OUTPUT is used. This should be used for referencing .config.
103
104# @ECLASS-VARIABLE: I_KNOW_WHAT_I_AM_DOING
105# @DESCRIPTION:
106# Temporary variable for the migration to making linux-info non-fatal.
91 107
92# And to ensure all the weirdness with crosscompile 108# And to ensure all the weirdness with crosscompile
93inherit toolchain-funcs versionator 109inherit toolchain-funcs versionator
94 110
95EXPORT_FUNCTIONS pkg_setup 111EXPORT_FUNCTIONS pkg_setup
143 159
144# @FUNCTION: getfilevar 160# @FUNCTION: getfilevar
145# @USAGE: variable configfile 161# @USAGE: variable configfile
146# @RETURN: the value of the variable 162# @RETURN: the value of the variable
147# @DESCRIPTION: 163# @DESCRIPTION:
148# It detects the value of the variable defined in the file configfile 164# It detects the value of the variable defined in the file configfile. This is
165# done by including the configfile, and printing the variable with Make.
166# It WILL break if your makefile has missing dependencies!
149getfilevar() { 167getfilevar() {
150local ERROR workingdir basefname basedname myARCH="${ARCH}" 168local ERROR basefname basedname myARCH="${ARCH}"
151 ERROR=0 169 ERROR=0
152 170
153 [ -z "${1}" ] && ERROR=1 171 [ -z "${1}" ] && ERROR=1
154 [ ! -f "${2}" ] && ERROR=1 172 [ ! -f "${2}" ] && ERROR=1
155 173
157 then 175 then
158 echo -e "\n" 176 echo -e "\n"
159 eerror "getfilevar requires 2 variables, with the second a valid file." 177 eerror "getfilevar requires 2 variables, with the second a valid file."
160 eerror " getfilevar <VARIABLE> <CONFIGFILE>" 178 eerror " getfilevar <VARIABLE> <CONFIGFILE>"
161 else 179 else
162 workingdir="${PWD}"
163 basefname="$(basename ${2})" 180 basefname="$(basename ${2})"
164 basedname="$(dirname ${2})" 181 basedname="$(dirname ${2})"
165 unset ARCH 182 unset ARCH
166 183
167 cd "${basedname}"
168 echo -e "e:\\n\\t@echo \$(${1})\\ninclude ${basefname}" | \ 184 echo -e "e:\\n\\t@echo \$(${1})\\ninclude ${basefname}" | \
169 make M="${S}" ${BUILD_FIXES} -s -f - 2>/dev/null 185 make -C "${basedname}" M="${S}" ${BUILD_FIXES} -s -f - 2>/dev/null
170 cd "${workingdir}"
171 186
172 ARCH=${myARCH} 187 ARCH=${myARCH}
173 fi 188 fi
174} 189}
175 190
191# @FUNCTION: getfilevar_noexec
192# @USAGE: variable configfile
193# @RETURN: the value of the variable
194# @DESCRIPTION:
195# It detects the value of the variable defined in the file configfile.
196# This is done with sed matching an expression only. If the variable is defined,
197# you will run into problems. See getfilevar for those cases.
198getfilevar_noexec() {
199 local ERROR basefname basedname mycat myARCH="${ARCH}"
200 ERROR=0
201 mycat='cat'
202
203 [ -z "${1}" ] && ERROR=1
204 [ ! -f "${2}" ] && ERROR=1
205 [ "${2#.gz}" != "${2}" ] && mycat='zcat'
206
207 if [ "${ERROR}" = 1 ]
208 then
209 echo -e "\n"
210 eerror "getfilevar_noexec requires 2 variables, with the second a valid file."
211 eerror " getfilevar_noexec <VARIABLE> <CONFIGFILE>"
212 else
213 ${mycat} "${2}" | \
214 sed -n \
215 -e "/^[[:space:]]*${1}[[:space:]]*=[[:space:]]*\(.*\)\$/{
216 s,^[^=]*[[:space:]]*=[[:space:]]*,,g ;
217 s,[[:space:]]*\$,,g ;
218 p
219 }"
220 fi
221}
222
223
224# @FUNCTION: linux_config_src_exists
225# @RETURN: true or false
226# @DESCRIPTION:
227# It returns true if .config exists in a build directory otherwise false
228linux_config_src_exists() {
229 [ -s "${KV_OUT_DIR}/.config" ]
230}
231
232# @FUNCTION: linux_config_bin_exists
233# @RETURN: true or false
234# @DESCRIPTION:
235# It returns true if .config exists in /proc, otherwise false
236linux_config_bin_exists() {
237 [ -s "/proc/config.gz" ]
238}
176 239
177# @FUNCTION: linux_config_exists 240# @FUNCTION: linux_config_exists
178# @RETURN: true or false 241# @RETURN: true or false
179# @DESCRIPTION: 242# @DESCRIPTION:
180# It returns true if .config exists otherwise false 243# It returns true if .config exists otherwise false
244#
245# This function MUST be checked before using any of the linux_chkconfig_*
246# functions.
181linux_config_exists() { 247linux_config_exists() {
182 [ -s "${KV_OUT_DIR}/.config" ] 248 linux_config_src_exists || linux_config_bin_exists
183} 249}
184 250
185# @FUNCTION: require_configured_kernel 251# @FUNCTION: require_configured_kernel
186# @DESCRIPTION: 252# @DESCRIPTION:
187# This function verifies that the current kernel is configured (it checks against the existence of .config) 253# This function verifies that the current kernel is configured (it checks against the existence of .config)
188# otherwise it dies. 254# otherwise it dies.
189require_configured_kernel() { 255require_configured_kernel() {
190 if ! linux_config_exists; then 256 if ! linux_config_src_exists; then
191 qeerror "Could not find a usable .config in the kernel source directory." 257 qeerror "Could not find a usable .config in the kernel source directory."
192 qeerror "Please ensure that ${KERNEL_DIR} points to a configured set of Linux sources." 258 qeerror "Please ensure that ${KERNEL_DIR} points to a configured set of Linux sources."
193 qeerror "If you are using KBUILD_OUTPUT, please set the environment var so that" 259 qeerror "If you are using KBUILD_OUTPUT, please set the environment var so that"
194 qeerror "it points to the necessary object directory so that it might find .config." 260 qeerror "it points to the necessary object directory so that it might find .config."
195 die "Kernel not configured; no .config found in ${KV_OUT_DIR}" 261 die "Kernel not configured; no .config found in ${KV_OUT_DIR}"
198 264
199# @FUNCTION: linux_chkconfig_present 265# @FUNCTION: linux_chkconfig_present
200# @USAGE: option 266# @USAGE: option
201# @RETURN: true or false 267# @RETURN: true or false
202# @DESCRIPTION: 268# @DESCRIPTION:
203# It checks that CONFIG_<option>=y or CONFIG_<option>=n is present in the current kernel .config 269# It checks that CONFIG_<option>=y or CONFIG_<option>=m is present in the current kernel .config
270# If linux_config_exists returns false, the results of this are UNDEFINED. You
271# MUST call linux_config_exists first.
204linux_chkconfig_present() { 272linux_chkconfig_present() {
205local RESULT 273local RESULT
206 require_configured_kernel 274 [ -z "${I_KNOW_WHAT_I_AM_DOING}" ] && require_configured_kernel
275 local config
276 config="${KV_OUT_DIR}/.config"
277 [ ! -f "${config}" ] && config="/proc/config.gz"
207 RESULT="$(getfilevar CONFIG_${1} ${KV_OUT_DIR}/.config)" 278 RESULT="$(getfilevar_noexec CONFIG_${1} "${config}")"
208 [ "${RESULT}" = "m" -o "${RESULT}" = "y" ] && return 0 || return 1 279 [ "${RESULT}" = "m" -o "${RESULT}" = "y" ] && return 0 || return 1
209} 280}
210 281
211# @FUNCTION: linux_chkconfig_module 282# @FUNCTION: linux_chkconfig_module
212# @USAGE: option 283# @USAGE: option
213# @RETURN: true or false 284# @RETURN: true or false
214# @DESCRIPTION: 285# @DESCRIPTION:
215# It checks that CONFIG_<option>=m is present in the current kernel .config 286# It checks that CONFIG_<option>=m is present in the current kernel .config
287# If linux_config_exists returns false, the results of this are UNDEFINED. You
288# MUST call linux_config_exists first.
216linux_chkconfig_module() { 289linux_chkconfig_module() {
217local RESULT 290local RESULT
218 require_configured_kernel 291 [ -z "${I_KNOW_WHAT_I_AM_DOING}" ] && require_configured_kernel
292 local config
293 config="${KV_OUT_DIR}/.config"
294 [ ! -f "${config}" ] && config="/proc/config.gz"
219 RESULT="$(getfilevar CONFIG_${1} ${KV_OUT_DIR}/.config)" 295 RESULT="$(getfilevar_noexec CONFIG_${1} "${config}")"
220 [ "${RESULT}" = "m" ] && return 0 || return 1 296 [ "${RESULT}" = "m" ] && return 0 || return 1
221} 297}
222 298
223# @FUNCTION: linux_chkconfig_builtin 299# @FUNCTION: linux_chkconfig_builtin
224# @USAGE: option 300# @USAGE: option
225# @RETURN: true or false 301# @RETURN: true or false
226# @DESCRIPTION: 302# @DESCRIPTION:
227# It checks that CONFIG_<option>=y is present in the current kernel .config 303# It checks that CONFIG_<option>=y is present in the current kernel .config
304# If linux_config_exists returns false, the results of this are UNDEFINED. You
305# MUST call linux_config_exists first.
228linux_chkconfig_builtin() { 306linux_chkconfig_builtin() {
229local RESULT 307local RESULT
230 require_configured_kernel 308 [ -z "${I_KNOW_WHAT_I_AM_DOING}" ] && require_configured_kernel
309 local config
310 config="${KV_OUT_DIR}/.config"
311 [ ! -f "${config}" ] && config="/proc/config.gz"
231 RESULT="$(getfilevar CONFIG_${1} ${KV_OUT_DIR}/.config)" 312 RESULT="$(getfilevar_noexec CONFIG_${1} "${config}")"
232 [ "${RESULT}" = "y" ] && return 0 || return 1 313 [ "${RESULT}" = "y" ] && return 0 || return 1
233} 314}
234 315
235# @FUNCTION: linux_chkconfig_string 316# @FUNCTION: linux_chkconfig_string
236# @USAGE: option 317# @USAGE: option
237# @RETURN: CONFIG_<option> 318# @RETURN: CONFIG_<option>
238# @DESCRIPTION: 319# @DESCRIPTION:
239# It prints the CONFIG_<option> value of the current kernel .config (it requires a configured kernel). 320# It prints the CONFIG_<option> value of the current kernel .config (it requires a configured kernel).
321# If linux_config_exists returns false, the results of this are UNDEFINED. You
322# MUST call linux_config_exists first.
240linux_chkconfig_string() { 323linux_chkconfig_string() {
241 require_configured_kernel 324 [ -z "${I_KNOW_WHAT_I_AM_DOING}" ] && require_configured_kernel
325 local config
326 config="${KV_OUT_DIR}/.config"
327 [ ! -f "${config}" ] && config="/proc/config.gz"
242 getfilevar "CONFIG_${1}" "${KV_OUT_DIR}/.config" 328 getfilevar_noexec "CONFIG_${1}" "${config}"
243} 329}
244 330
245# Versioning Functions 331# Versioning Functions
246# --------------------------------------- 332# ---------------------------------------
247 333
290 3) for((y=0; y<$((3 - ${#KV_PATCH})); y++)); do test="${test}0"; done; 376 3) for((y=0; y<$((3 - ${#KV_PATCH})); y++)); do test="${test}0"; done;
291 test="${test}${KV_PATCH}";; 377 test="${test}${KV_PATCH}";;
292 *) die "Error in kernel-2_kernel_is(): Too many parameters.";; 378 *) die "Error in kernel-2_kernel_is(): Too many parameters.";;
293 esac 379 esac
294 done 380 done
295 381
296 [ ${test} ${operator} ${value} ] && return 0 || return 1 382 [ ${test} ${operator} ${value} ] && return 0 || return 1
297} 383}
298 384
299get_localversion() { 385get_localversion() {
300 local lv_list i x 386 local lv_list i x
366 # so we better find it eh? 452 # so we better find it eh?
367 # do we pass KBUILD_OUTPUT on the CLI? 453 # do we pass KBUILD_OUTPUT on the CLI?
368 OUTPUT_DIR="${OUTPUT_DIR:-${KBUILD_OUTPUT}}" 454 OUTPUT_DIR="${OUTPUT_DIR:-${KBUILD_OUTPUT}}"
369 455
370 # And if we didn't pass it, we can take a nosey in the Makefile 456 # And if we didn't pass it, we can take a nosey in the Makefile
371 kbuild_output="$(getfilevar KBUILD_OUTPUT ${KV_DIR}/Makefile)" 457 kbuild_output="$(getfilevar_noexec KBUILD_OUTPUT ${KV_DIR}/Makefile)"
372 OUTPUT_DIR="${OUTPUT_DIR:-${kbuild_output}}" 458 OUTPUT_DIR="${OUTPUT_DIR:-${kbuild_output}}"
373 459
374 # And contrary to existing functions I feel we shouldn't trust the 460 # And contrary to existing functions I feel we shouldn't trust the
375 # directory name to find version information as this seems insane. 461 # directory name to find version information as this seems insane.
376 # so we parse ${KV_DIR}/Makefile 462 # so we parse ${KV_DIR}/Makefile
377 KV_MAJOR="$(getfilevar VERSION ${KV_DIR}/Makefile)" 463 KV_MAJOR="$(getfilevar_noexec VERSION ${KV_DIR}/Makefile)"
378 KV_MINOR="$(getfilevar PATCHLEVEL ${KV_DIR}/Makefile)" 464 KV_MINOR="$(getfilevar_noexec PATCHLEVEL ${KV_DIR}/Makefile)"
379 KV_PATCH="$(getfilevar SUBLEVEL ${KV_DIR}/Makefile)" 465 KV_PATCH="$(getfilevar_noexec SUBLEVEL ${KV_DIR}/Makefile)"
380 KV_EXTRA="$(getfilevar EXTRAVERSION ${KV_DIR}/Makefile)" 466 KV_EXTRA="$(getfilevar_noexec EXTRAVERSION ${KV_DIR}/Makefile)"
381 467
382 if [ -z "${KV_MAJOR}" -o -z "${KV_MINOR}" -o -z "${KV_PATCH}" ] 468 if [ -z "${KV_MAJOR}" -o -z "${KV_MINOR}" -o -z "${KV_PATCH}" ]
383 then 469 then
384 qeerror "Could not detect kernel version." 470 qeerror "Could not detect kernel version."
385 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources." 471 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources."
521 if [[ ${config_required} == 0 ]]; then 607 if [[ ${config_required} == 0 ]]; then
522 # In the case where we don't require a .config, we can now bail out 608 # In the case where we don't require a .config, we can now bail out
523 # if the user has no .config as there is nothing to do. Otherwise 609 # if the user has no .config as there is nothing to do. Otherwise
524 # code later will cause a failure due to missing .config. 610 # code later will cause a failure due to missing .config.
525 if ! linux_config_exists; then 611 if ! linux_config_exists; then
612 ewarn "Unable to check for the following kernel config options due"
613 ewarn "to absence of any configured kernel sources:"
614 for config in ${CONFIG_CHECK}; do
615 ewarn " - ${config#\~}"
616 done
617 ewarn "You're on your own to make sure they are set if needed."
526 return 0 618 return 0
527 fi 619 fi
528 else 620 else
529 require_configured_kernel 621 require_configured_kernel
530 fi 622 fi
531 623
532 einfo "Checking for suitable kernel configuration options..." 624 einfo "Checking for suitable kernel configuration options..."
533 625
534 for config in ${CONFIG_CHECK} 626 for config in ${CONFIG_CHECK}
535 do 627 do
536 # if we specify any fatal, ensure we honor them 628 # if we specify any fatal, ensure we honor them
537 die=1 629 die=1
538 error=0 630 error=0
636 local DEFLATE 728 local DEFLATE
637 729
638 einfo "Determining the usability of ZLIB_INFLATE support in your kernel" 730 einfo "Determining the usability of ZLIB_INFLATE support in your kernel"
639 731
640 ebegin "checking ZLIB_INFLATE" 732 ebegin "checking ZLIB_INFLATE"
641 getfilevar_isbuiltin CONFIG_ZLIB_INFLATE ${KV_DIR}/.config 733 linux_chkconfig_builtin CONFIG_ZLIB_INFLATE
642 eend $? 734 eend $?
643 [ "$?" != 0 ] && die 735 [ "$?" != 0 ] && die
644 736
645 ebegin "checking ZLIB_DEFLATE" 737 ebegin "checking ZLIB_DEFLATE"
646 getfilevar_isbuiltin CONFIG_ZLIB_DEFLATE ${KV_DIR}/.config 738 linux_chkconfig_builtin CONFIG_ZLIB_DEFLATE
647 eend $? 739 eend $?
648 [ "$?" != 0 ] && die 740 [ "$?" != 0 ] && die
649 741
650 local LINENO_START 742 local LINENO_START
651 local LINENO_END 743 local LINENO_END
694# @FUNCTION: linux-info_pkg_setup 786# @FUNCTION: linux-info_pkg_setup
695# @DESCRIPTION: 787# @DESCRIPTION:
696# Force a get_version() call when inherited from linux-mod.eclass and then check if the kernel is configured 788# Force a get_version() call when inherited from linux-mod.eclass and then check if the kernel is configured
697# to support the options specified in CONFIG_CHECK (if not null) 789# to support the options specified in CONFIG_CHECK (if not null)
698linux-info_pkg_setup() { 790linux-info_pkg_setup() {
699 get_version || die "Unable to calculate Linux Kernel version" 791 get_version
792 if [[ $rc -ne 0 ]]; then
793 ewarn "Unable to calculate Linux Kernel version for build, attempting to use running version"
794 get_running_version
795 fi
700 796
701 if kernel_is 2 4; then 797 if kernel_is 2 4; then
702 if [ "$( gcc-major-version )" -eq "4" ] ; then 798 if [ "$( gcc-major-version )" -eq "4" ] ; then
703 echo 799 echo
704 ewarn "Be warned !! >=sys-devel/gcc-4.0.0 isn't supported with" 800 ewarn "Be warned !! >=sys-devel/gcc-4.0.0 isn't supported with"

Legend:
Removed from v.1.56  
changed lines
  Added in v.1.62

  ViewVC Help
Powered by ViewVC 1.1.20